#include <stdio.h>
#include <mpi.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include <memory.h>

#define TAG 1

int main(int argc, char ** argv) {

//The only argument here is the range, R, of the random numbers.
//Each node will generate a random number, and the whole list of
//Numbers will be gathered into an array by the master node.

	int my_rank, world_size;

        char message[256], name[80];
        MPI_Status status;

	int j = 0;
	int k = 0;
	int R = atoi(argv[1]);

	int *RandomArray = NULL;

	MPI_Init(&argc, &argv); /* note that argc and argv are passed by address */

        MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);
        MPI_Comm_size(MPI_COMM_WORLD, &world_size);
	
	// If we put the random number generator stuff in here, maybe it can be more "random"
	int seed;
	double rand1 = 0.0;
	double temp = 0.0;
	seed = time(NULL)+my_rank;
	srand(seed);

	int randval;
	int newrandval;

	if (my_rank == 0)
	{
		// Only master node needs to create an array for the random numbers
		RandomArray = (int *)malloc(world_size*sizeof(int));
	}

	// Since outside of an if (my_rank == ...), all nodes do this number generation:
	rand1 = rand();
	temp = rand1 / (double) RAND_MAX;
	randval = R*temp;
	printf("Node %d: My random number is %d \n", my_rank, randval);

	// Same here, all nodes read MPI_Gather, but the result is sent to node 0.
	MPI_Gather(&randval, 1, MPI_INT, RandomArray, 1, MPI_INT, 0, MPI_COMM_WORLD);
	
	// Now let us make sure we got the right numbers and that they went to the right places!
	if (my_rank == 0)
	{
		while(j < world_size)
		{
			printf("Node %d: Entry %d in my array is %d \n", my_rank, j, RandomArray[j]);
			j++;
		}
	}

    MPI_Finalize();

}
